Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::MultiIndexQuantizer2 Struct Reference

`#include <IndexPQ.h>`

Inheritance diagram for faiss::MultiIndexQuantizer2:

## Public Member Functions
| MultiIndexQuantizer2 (int d, size_t M, size_t nbits, Index **indexes)
| MultiIndexQuantizer2 (int d, size_t nbits, Index *assign_index_0, Index *assign_index_1)
void | train (idx_t n, const float *x) override
void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
Public Member Functions inherited from faiss::MultiIndexQuantizer
| MultiIndexQuantizer (int d, size_t M, size_t nbits)
| number of bit per subvector index More...
void | add (idx_t n, const float *x) override
| add and reset will crash at runtime
void | reset () override
| removes all elements from the database.
void | reconstruct (idx_t key, float *recons) const override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_L2)
virtual void | add_with_ids (idx_t n, const float *x, const long *xids)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
virtual void | search_and_reconstruct (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const

## Public Attributes
std::vector< Index * > | assign_indexes
| M Indexes on d / M dimensions.
bool | own_fields
Public Attributes inherited from faiss::MultiIndexQuantizer
ProductQuantizer | pq
Public Attributes inherited from faiss::Index
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members
Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

MultiIndexQuantizer where the PQ assignmnet is performed by sub-indexes

Definition at line 160 of file IndexPQ.h.

## Member Function Documentation

void faiss::MultiIndexQuantizer2::search | ( | idx_t | n,
|  | const float * | x,
|  | idx_t | k,
|  | float * | distances,
|  | idx_t * | labels
| ) |  | const
| override virtual

query n vectors of dimension d to the index.

return at most k vectors. If there are not enough results for a query, the result array is padded with -1s.

Parameters

  x | input vectors to search, size n * d
  labels | output labels of the NNs, size n*k
  distances | output pairwise distances, size n*k

Reimplemented from faiss::MultiIndexQuantizer.

Definition at line 985 of file IndexPQ.cpp.

void faiss::MultiIndexQuantizer2::train | ( | idx_t | n,
|  | const float * | x
| ) |  |
| override virtual

Perform training on a representative set of vectors

Parameters

  n | nb of training vectors
  x | training vecors, size n * d

Reimplemented from faiss::MultiIndexQuantizer.

Definition at line 975 of file IndexPQ.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/IndexPQ.h
- /data/users/matthijs/github_faiss/faiss/IndexPQ.cpp